Katello - Bug #7621

Duplicate Operating Systems
09/24/2014 04:47 AM - Andreas Pfaffeneder

Status: Closed
Priority: High
Assignee: Justin Sherrill
Category: Hosts
Target version: Katello 2.0
Difficulty: easy Fixed in Releases:
Triaged: Yes Found in Releases:
Bugzilla link: 1150434 Red Hat JIRA:
Pull request: https://github.com/Katello/katello/pull/468
6
Description

Foreman 2.0 installed with foreman-deploy on centos 6, selinux=enforcing
Issue is, that | have synced three operating systems (fedora 20, centos 6.5 and centos7, all x86_64 only) from official mirrors.

The problem is that centos 7 and fedora 20 (but not centos 6) show aproximately 30-60 entries in the operating systems overview
which can be found below "Host" -> "Provisioning Setup".

Removing the redundant entries via Hammer works, but these show up again after some time with another os-id, which seems to be
incrimented straight.

| assume it is pulp related but not sure, so no category chosen.

Associated revisions

Revision 7bf74589 - 09/25/2014 03:03 PM - Justin Sherrill

fixes #7621 - treat a nil minor OS version as empty string

other wise we will forever create operating systems in foreman

Revision 5db696e7 - 09/25/2014 04:11 PM - Justin Sherrill
Merge pull request #4686 from jIsherrill/7621

fixes #7621 - treat a nil minor OS version as empty string

History

#1 - 09/24/2014 05:06 AM - Andreas Pfaffeneder
Sorry, Foreman 2.0 should be Katello 2.0.

#2 - 09/24/2014 08:55 AM - Andreas Pfaffeneder

URLs synced, excluding Centos 6.5 because this seems to work:

Centos 7:

http://ftp- .fht-esslingen. Mirror ntos/7/cen lus/x86_64/
http://ftp-stud.fht-esslingen.de/pub/Mirrors/centos/7/extras/x86_64/
http://ftp-stud.fht-esslingen.de/pub/Mirrors/centos/7/fasttrack/x86_64/
http:/ftp-stud.fht-esslingen.de/pub/Mirrors/centos/7/0s/x86_64/
http://ftp-stud.fht-esslingen.de/pub/Mirrors/centos/7/0s/x86_64/

http://ftp-stud.fht-esslingen.de/pub/Mirrors/centos/7/updates/x86_64/

http://ftp- .hs-esslingen. 1/7/x86_64
Fedora 20:
http://mirror2.hs-esslingen.de/fedora/linux/rel 20/Fedora/x 4

http:/ftp.uni-kl.de/pub/linux/fedora/linux/updates/20/x86_64/
http://ftp-stud.fht-esslingen.de/pub/Mirrors/centos/7/centosplus/x86_64/
http://ftp-stud.fht-esslingen.de/pub/Mirrors/centos/7/extras/x86_64/
http://ftp-stud.fht-esslingen.de/pub/Mirrors/centos/7/fasttrack/x86_64/
http://ftp-stud.fht-esslingen.de/pub/Mirrors/centos/7/os/x86_64/
http://ftp-stud.fht-esslingen.de/pub/Mirrors/centos/7/os/x86_64/
http://ftp-stud.fht-esslingen.de/pub/Mirrors/centos/7/updates/x86_64/
http://ftp-stud.hs-esslingen.de/pub/epel/7/x86_64/
http://mirror2.hs-esslingen.de/fedora/linux/releases/20/Fedora/x86_64/os/
http://ftp.uni-kl.de/pub/linux/fedora/linux/updates/20/x86_64/

#3 - 09/25/2014 01:12 AM - Andreas Pfaffeneder

Some news:
The content view (only containg Centos 6) was removed, the products centos7 and fedora20 have been removed, too, to get a clean state again.

Then | added a new product "Centos7" (capitalized C to distinguish from the old product). Again | synced the Mirror from
http:/ftp-stud.fht-esslingen.de/pub/Mirrors/centos/7/ and all subsequent repos. All synced fine except the OS-Repository:

1.) Pulp seems to have no problem syncing the repo, but some import-logic seems to fail:

/var/log/messages (with pulp-log=debug):

Sep 24 20:38:19 katello2 pulp: pulp.server.event.http:INFO: {'call_report": {u'exception': None, u'task_type":
u'pulp.server.tasks.repository.sync_with_auto_publish', u'task_id": u'34ff8e6f-d28a-4cee-8793-0da03d6d1779', u'tags':
[u'pulp:repository:pfaffeneder-Centos7-os_x86_64'", u'pulp:action:sync'], u'finish_time': None, u'_ns'": u'task_status', u'start_time':
u'2014-09-24T18:09:16Z', u'traceback’: None, u'spawned_tasks": [], u'progress_report': {u'yum_importer": {u'content": {u'size_total': 0, u'items_left": 0,
U'items_total'": 0, u'state': u'FINISHED', u'size_left": 0, u'details': {u'rpm_total": 0, u'rpm_done'": 0, u'drpm_total': 0, u'drpm_done': 0}, u'error_details": [},
u'comps': {u'state': u'FINISHED'}, u'distribution': {u'items_total": 6, u'state': u'FINISHED', u'error_details': [], u'items_left": 0}, u'errata’: {u'state":
U'FINISHED'}, u'metadata’: {u'state': u'FINISHED"}}, u'queue’: u'reserved_resource_worker-1@katello2.zuhause-local.de.dq’, u'state’: u'running’,
u'result': None, u'error': None, u'_id': Objectld('542308474854101afac13389'), u'id": u'56423084745347a07252cb6de'}, 'event_type': 'repo.sync.finish’,
'‘payload': {importer_id'": u'yum_importer', 'exception': None, 'repo_id": u'pfaffeneder-Centos7-os_x86_64", 'traceback’: None, 'started':
'2014-09-24T20:09:16+02:00', '_ns'": u'repo_sync_results', '‘completed': '2014-09-24T20:38:19+02:00', 'importer_type_id'": u'yum_importer',
'error_message': None, 'summary': {'content': {'state': 'FINISHED'}, 'comps': {'state': 'FINISHED'}, 'distribution': {'state": 'FINISHED'}, 'errata’: {'state":
'FINISHED'", 'metadata’: {'state’: 'FINISHED'"}, 'added_count'": 99, 'result': 'success', 'updated_count': 8466, 'details': {'content'": {'size_total": 0,
'items_left': 0, 'items_total": 0, 'state': 'FINISHED', 'size_left': 0, 'details': {'rpm_total': 0, 'rom_done": 0, 'drpm_total': 0, 'drpm_done": 0}, 'error_details":
[1}, 'comps': {'state': 'FINISHED'}, 'distribution': {'items_total': 6, 'state’: 'FINISHED", 'error_details': [], 'items_left': 0}, 'errata’: {'state': 'FINISHED'},
'metadata”:

2.) The import failing:

Id: 26d1433¢-9f85-4855-b661-679a491bb7df

Label: Actions::Katello::Repository::Sync

Name: Synchronize

Owner: admin

Started at: 2014-09-24 18:07:01 UTC

Ended at:

State: paused

Result: error

Params: repository 'os x86_64"; product 'Centos7'; organization 'pfaffeneder

Action:
Actions::Katello::Repository::UpdateMedia
Input:

{"repo_id"=>40, "locale"=>"en"}

Output:

{1

Exception:

ActiveRecord::RecordInvalid: Validation failed: Name has already been taken
Backtrace:

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/validations.rb:56:in “save!'
/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/attribute_methods/dirty.rb:33:in “save!'
/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:246:in “block in save!'
/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:295:in “block in with_transaction_returning_status'
/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/abstract/database_statements.rb:192:in
“transaction’

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:208:in “transaction’
/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:293:in “with_transaction_returning_status'
/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:246:in “save!'
/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/validations.rb:41:in “create!'
/opt/rh/ruby193/root/usr/share/gems/gems/katello-2.0.0/app/models/katello/concerns/medium_extensions.rb:53:in “find_or_create_medium'
/opt/rh/ruby193/root/usr/share/gems/gems/katello-2.0.0/app/models/katello/concerns/medium_extensions.rb:35:in “update_media’
/opt/rh/ruby193/root/usr/share/gems/gems/katello-2.0.0/app/lib/actions/katello/repository/update_media.rb:24:in “finalize'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/action.rb:465:in “block (2 levels) in execute_finalize'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware/stack.rb:26:in “call'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware/stack.rb:26:in “pass’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware.rb:16:in “pass’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/action/progress.rb:30:in “with_progress_calculation’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/action/progress.rb:22:in “finalize'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware/stack.rb:22:in “call'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware/stack.rb:26:in “pass’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware.rb:16:in “pass’
/opt/rh/ruby193/root/usr/share/gems/gems/katello-2.0.0/app/lib/actions/middleware/keep_locale.rb:28:in “block in finalize'
/opt/rh/ruby193/root/usr/share/gems/gems/katello-2.0.0/app/lib/actions/middleware/keep_locale.rb:35:in “with_locale'
/opt/rh/ruby193/root/usr/share/gems/gems/katello-2.0.0/app/lib/actions/middleware/keep_locale.rb:28:in “finalize'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware/stack.rb:22:in “call'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware/world.rb:30:in “execute'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/action.rb:464:in “block in execute_finalize'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/action.rb:365:in “call'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/action.rb:365:in “block in with_error_handling'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/action.rb:365:in “catch’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/action.rb:365:in “with_error_handling'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/action.rb:463:in “execute_finalize'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/action.rb:230:in “execute’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/execution_plan/steps/abstract_flow_step.rb:9:in “block (2 levels) in execute'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/execution_plan/steps/abstract.rb:152:in “call'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/execution_plan/steps/abstract.rb:152:in *with_meta_calculation’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/execution_plan/steps/abstract_flow_step.rb:8:in “block in execute’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/execution_plan/steps/abstract_flow_step.rb:22:in “open_action’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/execution_plan/steps/abstract_flow_step.rb:7:in “execute'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/executors/parallel/sequential_manager.rb:72:in “run_step'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/executors/parallel/sequential_manager.rb:57:in "dispatch'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/executors/parallel/sequential_manager.rb:64:in “block in run_in_sequence'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/executors/parallel/sequential_manager.rb:64:in “each’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/executors/parallel/sequential_manager.rb:64:in "all?'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/executors/parallel/sequential_manager.rb:64:in “run_in_sequence'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/executors/parallel/sequential_manager.rb:53:in "dispatch'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/executors/parallel/sequential_manager.rb:28:in "block (2 levels) in finalize'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware/stack.rb:26:in “call'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware/stack.rb:26:in “pass’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware.rb:16:in “pass’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware.rb:41:in *finalize_phase'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware/stack.rb:22:in “call'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware/stack.rb:26:in “pass’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware.rb:16:in “pass’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware.rb:41:in *finalize_phase'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware/stack.rb:22:in “call'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware/stack.rb:26:in “pass’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware.rb:16:in “pass’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware.rb:41:in “finalize_phase'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware/stack.rb:22:in “call'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/middleware/world.rb:30:in “execute'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/executors/parallel/sequential_manager.rb:27:in "block in finalize'
/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/abstract/database_statements.rb:192:in
“transaction’

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:208:in “transaction’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/transaction_adapters/active_record.rb:5:in “transaction’
/opt/rh/ruby193/root/ust/share/gems/gems/dynflow-0.7.3/lib/dynflow/executors/parallel/sequential_manager.rb:24:in “finalize'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/executors/parallel/worker.rb:23:in “block in on_message'
/opt/rh/ruby193/root/usr/share/gems/gems/algebrick-0.4.0/lib/algebrick.rb:859:in “block in assigns'
/opt/rh/ruby193/root/usr/share/gems/gems/algebrick-0.4.0/lib/algebrick.rb:858:in “tap'
/opt/rh/ruby193/root/usr/share/gems/gems/algebrick-0.4.0/lib/algebrick.rb:858:in “assigns'
/opt/rh/ruby193/root/usr/share/gems/gems/algebrick-0.4.0/lib/algebrick.rb:138:in “match_value'
/opt/rh/ruby193/root/usr/share/gems/gems/algebrick-0.4.0/lib/algebrick.rb:116:in “block in match'
/opt/rh/ruby193/root/usr/share/gems/gems/algebrick-0.4.0/lib/algebrick.rb:115:in “each’
/opt/rh/ruby193/root/usr/share/gems/gems/algebrick-0.4.0/lib/algebrick.rb:115:in “match’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/executors/parallel/worker.rb:17:in “on_message'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/micro_actor.rb:82:in “on_envelope'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/micro_actor.rb:72:in “receive'
/opt/rh/ruby193/root/ust/share/gems/gems/dynflow-0.7.3/lib/dynflow/micro_actor.rb:99:in “block (2 levels) in run'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/micro_actor.rb:99:in “loop’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/micro_actor.rb:99:in “block in run'
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/micro_actor.rb:99:in “catch’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/micro_actor.rb:99:in “run’
/opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.7.3/lib/dynflow/micro_actor.rb:13:in “block in initialize'
/opt/rh/ruby193/root/usr/share/gems/gems/logging-1.8.1/lib/logging/diagnostic_context.rb:323:in “call'
/opt/rh/ruby193/root/usr/share/gems/gems/logging-1.8.1/lib/logging/diagnostic_context.rb:323:in "block in create_with_logging_context'

And finaly looking at "Operating Systems" again: 41 entries, being Centos7 40 of them.

#4 - 09/25/2014 11:57 AM - The Foreman Bot
- Status changed from New to Ready For Testing

- Target version set to 56
- Pull request https://github.com/Katello/katello/pull/4686 added
- Pull request deleted ()

#5 - 09/25/2014 01:34 PM - Justin Sherrill
- Category set to 83

- Assignee set to Justin Sherrill

- Priority changed from Normal to High

- Difficulty set to easy

- Triaged changed from No to Yes

#6 - 09/25/2014 02:43 PM - Andreas Pfaffeneder

Applying the patch fixes the problem for Fedora 20 and Centos 7 without minor-version.
Please include in the release as soon as possible.

#7 - 09/25/2014 05:01 PM - Justin Sherrill

- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset katello|7bf74589a76ac5d8295a0aeb2032e4c7fb5fe407.

#8 - 01/27/2015 06:50 PM - Justin Sherrill
- Bugzilla link set to 1150434
